;*********************************************************************
;Direct color DMA test with built in image converter.
;Direct color DMA code by Chilly Willy
;Image converter and additional code by ComradeOj
;Contact: ComradeOj@yahoo.com
;*********************************************************************  
			  dc.l $FFFFFE,   start,     ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l HBlank,    ErrorTrap, VBlank,    ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.b "SEGA MEGASIS    "
              dc.b "2015 ComradeOj  "
              dc.b "Direct color DMA test program                   "
              dc.b "Direct color DMA test program                   "
              dc.b "GM 01234567-89"
              dc.w $DEAD        ;checksum
              dc.b "J               "
              dc.l 0
              dc.l ROM_End
              dc.l $FF0000
              dc.l $FFFFFF
              dc.b "    "
              dc.b "    "
              dc.b "    "
              dc.b "            "                           
              dc.b "This program contains blast processing! "
              dc.b "JUE             "
start:                          
        move.b  $A10001,d0
        andi.b  #$0F,d0
        beq.b   no_tmss         ;branch if oldest MD/GEN
        move.l  #'SEGA',$A14000 ;satisfy the TMSS        
no_tmss:
		move.w #$2700, sr       ;disable ints
		bsr clear_regs
		bsr clear_ram
        bsr setup_vdp
		bsr clear_vram	
		lea (image_end),a5		;The ass end of the BMP. Why are these things backwards?
		move.l #$FF0000,a0 		;ram start
		move.w #$7FF7,d4
		bsr convert_image	
		move.w #$8F00,(a3)		;auto increment	of zero
		clr d0			
loop:
		move.w #$8154,(a3)	;No V-INT, DMA enable, screen enable
		move.l	#$40000000, (A3)
vbwait1:
		btst.b	#3, $1(A3)
		beq	vbwait1
vbwait2:
		btst.b	#3, $1(A3)
		bne	vbwait2
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		move.w	D0, (a4)
		nop
		nop
		nop
		nop
		; move.w #$93f7,(a3) 	  ;DMA length
		; move.w #$9447,(a3)		
		; move.w #$9500,(a3)      ;00	
		; move.w #$9600,(a3)      ;00
		; move.w #$977f,(a3)      ;ff
		; move.w #$8114,(a3)		
		; move.l #$C0000080,(a3)			
		move.l	#$93f7947f, (A3) ;DMA length ($47F7)
		move.l	#$95009600, (A3) ;using long fixed the jitter issue for some reason...
		move.l	#$977f8114, (A3) 
		move.l	#$C0000080, (A3) ;Blast processing time!
		bra loop

setup_vdp:
        lea    $C00004.l,a3     ;VDP control port
	    lea    $C00000.l,a4     ;VDP data port
        lea    (VDPSetupArray).l,a5
        move.w #0018,d4         ;loop counter	
VDP_Loop:
        move.w (a5)+,(a3)       ;load setup array
	    nop
        dbf d4,VDP_Loop
        rts 
		
convert_image:
        move.b -(a5),d5  ;first byte
        move.b -(a5),d0  ;second byte
		lsl.w #$08,d5	 ;position it!
		add.w d5,d0		 ;smash them together. (Can't use .W, because of odd numbered address)
		move.w d0,d1	 ;save a copy of the data in d1 and d2
		move.w d0,d2
		andi.w #$7C00,d0 ;get red channel
		andi.w #$03E0,d1 ;green
		andi.w #$001F,d2 ;blue
		lsr.w #$08,d0	 ;get correct value (11 shifts for red)
		lsr.w #$03,d0
		andi.w #$0E,d0	 ;Not needed? Extra bit seems to be ignored by VDP.
		lsr.w #$06,d1
		andi.w #$0E,d1   ;Keeping these enabled just to be safe.	
		lsr.w #$01,d2
		andi.w #$0E,d2		
		lsl.w #$08,d2	 ;shift color bits into correct places.
		lsl.w #$04,d1	
		eor.w d0,d2		 ;add red to finished product
		eor.w d1,d2		 ;add green
        move.w d2,(a0)+  ;write finished product in to memory.
        dbf d4,convert_image
        rts  	
		
clear_regs:
		moveq #$00000000,d0
		moveq #$00000000,d1
		moveq #$00000000,d2
		moveq #$00000000,d3
		moveq #$00000000,d4
		moveq #$00000000,d5
		moveq #$00000000,d6
		moveq #$00000000,d7
		move.l d0,a0
		move.l d0,a1
		move.l d0,a2
		move.l d0,a3
		move.l d0,a4
		move.l d0,a5
		move.l d0,a6
		rts
		
clear_ram:
		move.w #$7FF0,d0
		move.l #$FF0000,a0	
clear_ram_loop:
		move.w #$0000,(a0)+
		dbf d0, clear_ram_loop
		rts	
		
clear_vram:
		move.l #$40000000,(a3)
		move.w #$7fff,d4
vram_clear_loop:
		move.w #$0000,(a4)
		dbf d4, vram_clear_loop
		rts		
		
ErrorTrap:        
        bra ErrorTrap
HBlank:
        rte
VBlank:
        rte	
		
VDPSetupArray:
	dc.w $8014		
	dc.w $8154  ;Genesis mode, DMA enabled, VBLANK-INT disabled		
	dc.w $8208	;field A    
	dc.w $8300	;$833e	
	dc.w $8401	;field B	
	dc.w $8518	;sprite
	dc.w $8600
	dc.w $8700  ;BG color		
	dc.w $8800
	dc.w $8900
	dc.w $8Aff  ;no H-INT	
	dc.w $8B00		
	dc.w $8C81	;40 wide mode, no S+H
	dc.w $8D34		
	dc.w $8E00
	dc.w $8F02	;auto increment	
	dc.w $9001		
	dc.w $9100		
	dc.w $9200

image:
	incbin "img/image.bmp"
image_end:
	
ROM_End:
              
              